'/*
'** $Id: lauxlib.h,v 1.88 2006/04/12 20:31:15 roberto Exp $
'** Auxiliary functions for building Lua libraries
'** See Copyright Notice in lua.h
'*/

#IF NOT %DEF(%LAUXLIB_INC)
    %LAUXLIB_INC = 1

'#ifndef lauxlib_h
'#define lauxlib_h

'#include <stddef.h>
'#include <stdio.h>

'#include "lua.h"
#INCLUDE "LUA.INC"

'#if defined(LUA_COMPAT_GETN)
'LUALIB_API int (luaL_getn) (lua_State *L, int t);
'LUALIB_API void (luaL_setn) (lua_State *L, int t, int n);
'#else
'#define luaL_getn(L,i)          ((int)lua_objlen(L, i))
'#define luaL_setn(L,i,j)        ((void)0)  /* no op! */
'#endif

'#if defined(LUA_COMPAT_OPENLIB)
'#define luaI_openlib	luaL_openlib
'#endif


'/* extra error code for `luaL_load' */
'#define LUA_ERRFILE     (LUA_ERRERR+1)
%LUA_ERRFILE = %LUA_ERRERR + 1


'typedef struct luaL_Reg {
'  const char *name;
'  lua_CFunction func;
'} luaL_Reg;

TYPE luaL_Reg
   name AS ASCIIZ PTR
   func AS DWORD
END TYPE


'LUALIB_API void (luaI_openlib) (lua_State *L, const char *libname,
'                                const luaL_Reg *l, int nup);

DECLARE SUB luaI_openlib LIB "LUA5.1.DLL" _
   ALIAS "luaI_openlib" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ, _                     ' const char *libname
   BYREF luaL_Reg, _                   ' const luaL_Reg *l
   BYVAL LONG _                        ' int nup
   )                                   ' void

'LUALIB_API void (luaL_register) (lua_State *L, const char *libname,
'                                const luaL_Reg *l);

DECLARE SUB luaL_register _
   LIB "LUA5.1.DLL" ALIAS "luaL_register" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ, _                     ' const char *libname
   BYREF luaL_Reg _                    ' const luaL_Reg *l
   )                                   ' void

'LUALIB_API int (luaL_getmetafield) (lua_State *L, int obj, const char *e);

DECLARE FUNCTION luaL_getmetafield _
   LIB "LUA5.1.DLL" ALIAS "luaL_getmetafield" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int obj
   BYREF ASCIIZ _                      ' const char *e
   ) AS LONG                           ' int

'LUALIB_API int (luaL_callmeta) (lua_State *L, int obj, const char *e);

DECLARE FUNCTION luaL_callmeta _
   LIB "LUA5.1.DLL" ALIAS "luaL_callmeta" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int obj
   BYREF ASCIIZ _                      ' const char *e
   ) AS LONG                           ' int

'LUALIB_API int (luaL_typerror) (lua_State *L, int narg, const char *tname);

DECLARE FUNCTION luaL_typerror _
   LIB "LUA5.1.DLL" ALIAS "luaL_typerror" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int narg
   BYREF ASCIIZ _                      ' const char *tname
   ) AS LONG                           ' int

'LUALIB_API int (luaL_argerror) (lua_State *L, int numarg, const char *extramsg);

DECLARE FUNCTION luaL_argerror _
   LIB "LUA5.1.DLL" ALIAS "luaL_argerror" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int numarg
   BYREF ASCIIZ _                      ' const char *extramsg
   ) AS LONG                           ' int

'LUALIB_API const char *(luaL_checklstring) (lua_State *L, int numArg, size_t *l);

DECLARE FUNCTION luaL_checklstring _
   LIB "LUA5.1.DLL" ALIAS "luaL_checklstring" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int numArg
   BYREF DWORD _                       ' size_t *l
   ) AS DWORD                          ' const char *

'LUALIB_API const char *(luaL_optlstring) (lua_State *L, int numArg, const char *def, size_t *l);

DECLARE FUNCTION luaL_optlstring _
   LIB "LUA5.1.DLL" ALIAS "luaL_optlstring" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int numArg
   BYREF ASCIIZ, _                     ' const char *def
   BYREF DWORD _                       ' size_t *l
   ) AS DWORD                          ' const char *

'LUALIB_API lua_Number (luaL_checknumber) (lua_State *L, int numArg);

DECLARE FUNCTION luaL_checknumber _
   LIB "LUA5.1.DLL" ALIAS "luaL_checknumber" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG _                        ' int numArg
   ) AS DOUBLE                         ' lua_Number

'LUALIB_API lua_Number (luaL_optnumber) (lua_State *L, int nArg, lua_Number def);

DECLARE FUNCTION luaL_optnumber _
   LIB "LUA5.1.DLL" ALIAS "luaL_optnumber" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int nArg
   BYVAL DOUBLE _                      ' lua_Number def
   ) AS DOUBLE                         ' lua_Number

'LUALIB_API lua_Integer (luaL_checkinteger) (lua_State *L, int numArg);

DECLARE FUNCTION luaL_checkinteger _
   LIB "LUA5.1.DLL" ALIAS "luaL_checkinteger" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG _                        ' int numArg
   ) AS LONG                           ' lua_Integer

'LUALIB_API lua_Integer (luaL_optinteger) (lua_State *L, int nArg, lua_Integer def);

DECLARE FUNCTION luaL_optinteger _
   LIB "LUA5.1.DLL" ALIAS "luaL_optinteger" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int nArg
   BYVAL LONG _                        ' lua_Integer def
   ) AS LONG                           ' lua_Integer

'LUALIB_API void (luaL_checkstack) (lua_State *L, int sz, const char *msg);

DECLARE SUB luaL_checkstack _
   LIB "LUA5.1.DLL" ALIAS "luaL_checkstack" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int sz
   BYREF ASCIIZ _                      ' const char *msg
   )                                   ' void

'LUALIB_API void (luaL_checktype) (lua_State *L, int narg, int t);

DECLARE SUB luaL_checktype _
   LIB "LUA5.1.DLL" ALIAS "luaL_checktype" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int narg
   BYVAL LONG _                        ' int t
   )                                   ' void

'LUALIB_API void (luaL_checkany) (lua_State *L, int narg);

DECLARE SUB luaL_checkany _
   LIB "LUA5.1.DLL" ALIAS "luaL_checkany" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG _                        ' int narg
   )                                   ' void

'LUALIB_API int   (luaL_newmetatable) (lua_State *L, const char *tname);

DECLARE FUNCTION luaL_newmetatable _
   LIB "LUA5.1.DLL" ALIAS "luaL_newmetatable" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ _                      ' const char *tname
   ) AS LONG                           ' int

'LUALIB_API void *(luaL_checkudata) (lua_State *L, int ud, const char *tname);

DECLARE SUB luaL_checkudata _
   LIB "LUA5.1.DLL" ALIAS "luaL_checkudata" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG,_                        ' int ud
   BYREF ASCIIZ _                      ' const char *tname
   )                                   ' void

'LUALIB_API void (luaL_where) (lua_State *L, int lvl);

DECLARE SUB luaL_where _
   LIB "LUA5.1.DLL" ALIAS "luaL_where" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG _                        ' int lvl
   )                                   ' void

'LUALIB_API int (luaL_error) (lua_State *L, const char *fmt, ...);

DECLARE FUNCTION luaL_error _
   CDECL LIB "LUA5.1.DLL" ALIAS "luaL_error" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ, _                     ' const char *fmt
   BYREF ANY, _                        ' arguments
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY, _
   BYREF ANY _
   ) AS LONG                           ' void


'LUALIB_API int (luaL_checkoption) (lua_State *L, int narg, const char *def,
'                                   const char *const lst[]);

DECLARE FUNCTION luaL_checkoption _
   LIB "LUA5.1.DLL" ALIAS "luaL_checkoption" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int narg
   BYREF ASCIIZ, _                     ' const char *def
   BYREF ASCIIZ _                      ' const char *const lst[]
   ) AS LONG                           ' int

'LUALIB_API int (luaL_ref) (lua_State *L, int t);

DECLARE FUNCTION luaL_ref _
   LIB "LUA5.1.DLL" ALIAS "luaL_ref" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG _                        ' int t
   ) AS LONG                           ' int

'LUALIB_API void (luaL_unref) (lua_State *L, int t, int ref);

DECLARE SUB luaL_unref _
   LIB "LUA5.1.DLL" ALIAS "luaL_unref" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int t
   BYVAL LONG _                        ' int ref
   )                                   ' void

'LUALIB_API int (luaL_loadfile) (lua_State *L, const char *filename);

DECLARE FUNCTION luaL_loadfile _
   LIB "LUA5.1.DLL" ALIAS "luaL_loadfile" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ _                      ' const char *filename
   ) AS LONG                           ' int

'LUALIB_API int (luaL_loadbuffer) (lua_State *L, const char *buff, size_t sz,
'                                  const char *name);

DECLARE FUNCTION luaL_loadbuffer _
   LIB "LUA5.1.DLL" ALIAS "luaL_loadbuffer" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ, _                     ' const char *buff
   BYVAL DWORD, _                      ' size_t sz
   BYREF ASCIIZ _                      ' const char *name
   ) AS LONG                           ' int

'LUALIB_API int (luaL_loadstring) (lua_State *L, const char *s);

DECLARE FUNCTION luaL_loadstring _
   LIB "LUA5.1.DLL" ALIAS "luaL_loadstring" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ _                      ' const char *s
   ) AS LONG                           ' int

'LUALIB_API lua_State *(luaL_newstate) (void);

DECLARE FUNCTION luaL_newstate _
   LIB "LUA5.1.DLL" ALIAS "luaL_newstate" ( _
   ) AS DWORD                          ' void

'LUALIB_API const char *(luaL_gsub) (lua_State *L, const char *s, const char *p,
'                                                  const char *r);

DECLARE FUNCTION luaL_gsub _
   LIB "LUA5.1.DLL" ALIAS "luaL_gsub" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF ASCIIZ, _                     ' const char *s
   BYREF ASCIIZ, _                     ' const char *p
   BYREF ASCIIZ _                      ' const char *r
   ) AS DWORD                          ' const char *

'LUALIB_API const char *(luaL_findtable) (lua_State *L, int idx,
'                                         const char *fname, int szhint);


DECLARE FUNCTION luaL_findtable _
   LIB "LUA5.1.DLL" ALIAS "luaL_findtable" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYVAL LONG, _                       ' int idx
   BYREF ASCIIZ, _                     ' const char *fname
   BYVAL LONG _                        ' int szhint
   ) AS DWORD                          ' const char *


'/*
'** ===============================================================
'** some useful macros
'** ===============================================================
'*/

'#define luaL_argcheck(L, cond,numarg,extramsg)	\
'		((void)((cond) || luaL_argerror(L, (numarg), (extramsg))))

FUNCTION luaL_argcheck (BYVAL L AS DWORD, BYVAL cond AS DWORD, BYVAL numarg AS LONG, BYREF extramsg AS ASCIIZ) AS LONG
   LOCAL lr AS LONG
   FUNCTION = luaL_argerror(L, numarg, extramsg)
   FUNCTION = cond OR lr
END FUNCTION

'#define luaL_checkstring(L,n)	(luaL_checklstring(L, (n), NULL))

MACRO luaL_checkstring(L,n) = luaL_checklstring(L, n, %NULL)

'#define luaL_optstring(L,n,d)	(luaL_optlstring(L, (n), (d), NULL))

MACRO luaL_optstring(L,n) = luaL_optlstring(L, n, d, %NULL)

'#define luaL_checkint(L,n)	((int)luaL_checkinteger(L, (n)))

MACRO luaL_checkint(L,n) = luaL_checkinteger(L, n)

'#define luaL_optint(L,n,d)	((int)luaL_optinteger(L, (n), (d)))

MACRO luaL_optint(L,n,d) = luaL_optinteger(L, n, d)

'#define luaL_checklong(L,n)	((long)luaL_checkinteger(L, (n)))

MACRO luaL_checklong(L,n) = luaL_checkinteger(L, n)

'#define luaL_optlong(L,n,d)	((long)luaL_optinteger(L, (n), (d)))

MACRO luaL_optlong(L,n,d) = luaL_optinteger(L, n, d)

'#define luaL_typename(L,i)	lua_typename(L, lua_type(L,(i)))

MACRO luaL_typename(L,i) = lua_typename(L, lua_type(L, i))

'#define luaL_dofile(L, fn) \
'	(luaL_loadfile(L, fn) || lua_pcall(L, 0, LUA_MULTRET, 0))

FUNCTION luaL_dofile (BYVAL L AS DWORD, BYREF fn AS ASCIIZ) AS LONG
   LOCAL lr1, lr2 AS LONG
   lr1 = luaL_loadfile(L, fn)
   lr2 = lua_pcall(L, 0, %LUA_MULTRET, 0)
   FUNCTION = lr1 OR lr2
END FUNCTION

'#define luaL_dostring(L, s) \
'	(luaL_loadstring(L, s) || lua_pcall(L, 0, LUA_MULTRET, 0))

FUNCTION luaL_dostring(BYVAL L AS DWORD, BYREF s AS ASCIIZ) AS LONG
   LOCAL lr1, lr2 AS LONG
   lr1 = luaL_loadstring(L, s)
   lr2 = lua_pcall(L, 0, %LUA_MULTRET, 0)
   FUNCTION = lr1 OR lr2
END FUNCTION

'#define luaL_getmetatable(L,n)	(lua_getfield(L, LUA_REGISTRYINDEX, (n)))

MACRO luaL_getmetatable(L,n) = lua_getfield(L, %LUA_REGISTRYINDEX, n)

'#define luaL_opt(L,f,n,d)	(lua_isnoneornil(L,(n)) ? (d) : f(L,(n)))

'/*
'** {======================================================
'** Generic Buffer manipulation
'** =======================================================
'*/

'typedef struct luaL_Buffer {
'  char *p;			/* current position in buffer */
'  int lvl;  /* number of strings in the stack (level) */
'  lua_State *L;
'  char buffer[LUAL_BUFFERSIZE];
'} luaL_Buffer;

TYPE luaL_Buffer
  p      AS ASCIIZ PTR
  lvl    AS LONG
  L      AS DWORD
  buffer AS ASCIIZ * %LUAL_BUFFERSIZE
END TYPE

'#define luaL_addchar(B,c) \
'  ((void)((B)->p < ((B)->buffer+LUAL_BUFFERSIZE) || luaL_prepbuffer(B)), \
'   (*(B)->p++ = (char)(c)))

'/* compatibility only */
'#define luaL_putchar(B,c)	luaL_addchar(B,c)

'#define luaL_addsize(B,n)	((B)->p += (n))

'LUALIB_API void (luaL_buffinit) (lua_State *L, luaL_Buffer *B);

DECLARE SUB luaL_buffinit _
   LIB "LUA5.1.DLL" ALIAS "luaL_buffinit" ( _
   BYVAL DWORD, _                      ' lua_State *L
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
   )                                   ' void

'LUALIB_API char *(luaL_prepbuffer) (luaL_Buffer *B);

DECLARE FUNCTION luaL_prepbuffer _
   LIB "LUA5.1.DLL" ALIAS "luaL_prepbuffer" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
   ) AS DWORD                          ' char *

'LUALIB_API void (luaL_addlstring) (luaL_Buffer *B, const char *s, size_t l);

DECLARE SUB luaL_addlstring _
   LIB "LUA5.1.DLL" ALIAS "luaL_addlstring" ( _
   BYREF luaL_Buffer, _                ' luaL_Buffer *B
   BYREF ASCIIZ, _                     ' const char *s
   BYVAL DWORD _                       ' size_t l
   )                                   ' void

'LUALIB_API void (luaL_addstring) (luaL_Buffer *B, const char *s);

DECLARE SUB luaL_addstring _
   LIB "LUA5.1.DLL" ALIAS "luaL_addstring" ( _
   BYREF luaL_Buffer, _                ' luaL_Buffer *B
   BYREF ASCIIZ _                      ' const char *s
   )                                   ' void

'LUALIB_API void (luaL_addvalue) (luaL_Buffer *B);

DECLARE SUB luaL_addvalue _
   LIB "LUA5.1.DLL" ALIAS "luaL_addvalue" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
   )                                   ' void

'LUALIB_API void (luaL_pushresult) (luaL_Buffer *B);

DECLARE SUB luaL_pushresult _
   LIB "LUA5.1.DLL" ALIAS "luaL_pushresult" ( _
   BYREF luaL_Buffer _                 ' luaL_Buffer *B
   )                                   ' void


'/* }====================================================== */


'/* compatibility with ref system */

'/* pre-defined references */
'#define LUA_NOREF       (-2)
'#define LUA_REFNIL      (-1)

%LUA_NOREF       = -2
%LUA_REFNIL      = -1

'#define lua_ref(L,lock) ((lock) ? luaL_ref(L, LUA_REGISTRYINDEX) : \
'      (lua_pushstring(L, "unlocked references are obsolete"), lua_error(L), 0))

'#define lua_unref(L,ref)        luaL_unref(L, LUA_REGISTRYINDEX, (ref))

MACRO lua_unref(L,lref) = luaL_unref(L, %LUA_REGISTRYINDEX, lref)

'#define lua_getref(L,ref)       lua_rawgeti(L, LUA_REGISTRYINDEX, (ref))

MACRO lua_getref(L,lref) = lua_rawgeti(L, %LUA_REGISTRYINDEX, lref)

'#define luaL_reg	luaL_Reg

'#endif


#ENDIF
