'/*
'** $Id: lualib.h,v 1.36 2005/12/27 17:12:00 roberto Exp $
'** Lua standard libraries
'** See Copyright Notice in lua.h
'*/

 ' The state initialization procedure changed between Lua 5.0 and Lua 5.1. It is now
 ' necessary to lua_call the various luaopen_* functions. Previously, these were simply
 ' called with a normal C call, but doing so now will cause a crash or an error
 ' during the initialization of the io library.

#IF NOT %DEF(%LUALIB_INC)
    %LUALIB_INC = 1

'#ifndef lualib_h
'#define lualib_h

'#include "lua.h"
#INCLUDE "LUA.INC"


'/* Key to file-handle type */
'#define LUA_FILEHANDLE      "FILE*"
$LUA_FILEHANDLE = "FILE*"


'#define LUA_COLIBNAME   "coroutine"
'LUALIB_API int (luaopen_base) (lua_State *L);

$LUA_COLIBNAME = "coroutine"
DECLARE FUNCTION luaopen_base _
   LIB "LUA5.1.DLL" ALIAS "luaopen_base" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_TABLIBNAME   "table"
'LUALIB_API int (luaopen_table) (lua_State *L);

$LUA_TABLIBNAME = "table"
DECLARE FUNCTION luaopen_table _
   LIB "LUA5.1.DLL" ALIAS "luaopen_table" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_IOLIBNAME   "io"
'LUALIB_API int (luaopen_io) (lua_State *L);

$LUA_IOLIBNAME   = "io"
DECLARE FUNCTION luaopen_io _
   LIB "LUA5.1.DLL" ALIAS "luaopen_io" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_OSLIBNAME   "os"
'LUALIB_API int (luaopen_os) (lua_State *L);

$LUA_OSLIBNAME   = "os"
DECLARE FUNCTION luaopen_os _
   LIB "LUA5.1.DLL" ALIAS "luaopen_os" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_STRLIBNAME   "string"
'LUALIB_API int (luaopen_string) (lua_State *L);

$LUA_STRLIBNAME   = "string"
DECLARE FUNCTION luaopen_string _
   LIB "LUA5.1.DLL" ALIAS "luaopen_string" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_MATHLIBNAME   "math"
'LUALIB_API int (luaopen_math) (lua_State *L);

$LUA_MATHLIBNAME   = "math"
DECLARE FUNCTION luaopen_math _
   LIB "LUA5.1.DLL" ALIAS "luaopen_math" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_DBLIBNAME   "debug"
'LUALIB_API int (luaopen_debug) (lua_State *L);

$LUA_DBLIBNAME   = "debug"
DECLARE FUNCTION luaopen_debug _
   LIB "LUA5.1.DLL" ALIAS "luaopen_debug" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'#define LUA_LOADLIBNAME   "package"
'LUALIB_API int (luaopen_package) (lua_State *L);

$LUA_LOADLIBNAME   = "package"
DECLARE FUNCTION luaopen_package _
   LIB "LUA5.1.DLL" ALIAS "luaopen_package" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int

'/* open all previous libraries */
'LUALIB_API void (luaL_openlibs) (lua_State *L);

DECLARE FUNCTION luaL_openlibs _
   LIB "LUA5.1.DLL" ALIAS "luaL_openlibs" ( _
   BYVAL DWORD _                       ' lua_State *L
   ) AS LONG                           ' int


'#ifndef lua_assert
'#define lua_assert(x)   ((void)0)
'#endif


'#endif

#ENDIF
